
package handler::gocurrcalc;

use xParser;
use xCountry;
use xMisc;
use xData qw(six_digits);
use AdBanner;

use Data::Dumper;

use strict;

sub act
{
  my $conf = shift;
  die "could not find conf" unless $conf;
  
  # Country details
  my $ctry = load xCountry;


  # Debug country
  #print Dumper($ctry,[ $ctry ]);


  # data for yesterday, based on default ('USD')
  my ($data, $day) = xData::one_day();
  die unless $data;

  my %data = ( %$data, USD => 1 );

  # make javascript arrays and dropdown list
  my ( @currency_js, @country_js, @rate_js, @currency );

  #print Dumper($ctry,[ $ctry ]);

  for my $k
    (sort
     {
       $ctry->{$a}{currency} cmp $ctry->{$b}{currency}
     }
     keys %data)
  {
    push ( @currency_js, $k );
    push ( @country_js, $ctry->{$k}{iso3166} );
    push ( @rate_js, &xData::six_digits($data{$k}) );

    push ( @currency, $ctry->{$k}{currency} );
  }

  #print Dumper($country_js,[ $country_js ]);
  
  my $currency_js =
    'var currency = new Array("' .
      join('","', @currency_js) .
	'");';

  my $country_js =
    'var country = new Array("' .
      join('","', @country_js) .
	'");';

  #print Dumper($country_js,[ $country_js]);

  #not here

  my $rate_js =
    'var rate = new Array("' .
      join('","', @rate_js) .
	'");';

  my %tmp;
  for (0..$#currency_js) {
    $tmp{$currency_js[$_]} = $_;
  }

  my $head_js = qq{
$currency_js
$country_js
$rate_js

var fromFlag = new Array($tmp{USD},$tmp{GBP},$tmp{AUD},$tmp{EUR},$tmp{SGD},$tmp{JPY}); var nVal = 1;
var toFlag   = new Array($tmp{EUR},$tmp{GBP},$tmp{JPY},$tmp{INR},$tmp{AUD},$tmp{SGD});
};

  my $page = new xParser($conf);
  die unless $page;

  $page->{main_template} = "$conf->{dir_templates}/null.htm",

# '<script language="javaScript" src="/js/calculator.js"></script>';


  my $content = _get_content(\@currency, $day, $head_js);

  
  $page->content( $head_js . html2js( $content ) );

  return \$page->out;
}




sub _get_content
{
  my ($countries, $day, $head_js) = @_;

  my $options;
  for my $i (0..$#$countries)
  {
    $options .= qq{\t<OPTION VALUE="$i">$countries->[$i]</OPTION>\n};
  }
  
  
  my ($date) = &xMisc::date_format($day) =~ /^\w+, (.*)/;


  my $ret = qq{

<center>
<form name="calcForm">
<table width="220" border="0" cellpadding="0" cellspacing="0">
<tr>
<td width="65" align="right" valign="middle" colspan="1" style="font-family:Verdana, sans-serif; font-size:11px; font-weight:bold; color:#000000">Amount:&#160;</td>
<td width="155" align="left" valign="middle" colspan="1"><input type="text" name="inV" value="1" onChange="javascript:Cvalue();" size="20" maxlength="50" style="font-family:Arial, sans-serif; font-size:12px; font-weight:normal; color:#000000"></td>
</tr>
<tr>
<td height="11"></td>
</tr>
<tr>
<td width="65" align="right" valign="middle" colspan="1" style="font-family:Verdana, sans-serif; font-size:11px; font-weight:bold; color:#000000">From:&#160;</td>
<td width="155" align="left" valign="middle" colspan="1">
<SELECT NAME="from" onChange="Cvalue(); changeFlag();" style="font-family:Arial, sans-serif; font-size:12px; font-weight:normal; color:#000000"> 
$options
</SELECT>

</td>
</tr>
<tr>
<td height="11"></td>
</tr>
<td width="65" align="right" valign="middle" colspan="1" style="font-family:Verdana, sans-serif; font-size:11px; font-weight:bold; color:#000000">To:&#160;</td>
<td width="155" align="left" valign="middle" colspan="1">
<SELECT NAME="to" onChange="Cvalue(); changeFlag(\'to\');" style="font-family:Arial, sans-serif; font-size:12px; font-weight:normal; color:#000000">
$options
</SELECT>


</td>
</tr>
<tr>
<td height="11"></td>
</tr>
<tr>
<td width="65" align="right" valign="middle" colspan="1"></td>
<td width="155" align="left" valign="middle" colspan="1"><INPUT TYPE="button" VALUE="Convert" NAME="Calculate" onClick="return sendForm()" style="font-size:13px; font-family:Arial;"></td>
</tr>
<tr>
<td height="11"></td>
</tr>
<tr>
<td width="65" align="right" valign="middle" colspan="1" style="font-family:Verdana, sans-serif; font-size:11px; font-weight:bold; color:#000000">Result:&#160;</td>
<td width="155" align="left" valign="middle" colspan="1"><input type="Text" name="outV" value="" onFocus="blur()" size="20" maxlength="50" style="font-family:Arial, sans-serif; font-size:12px; font-weight:normal; color:#000000"></td>
</tr>
<tr>
<td width="220" height="35" align="center" valign="bottom" colspan="2"><a href="http://www.gocurrency.com" target="_blank"><img src="http://www.gocurrency.com/img/logo-poweredby.gif" width="170" height="20" border="0"></a></td>
</tr>

</table></form></center>};

  return $ret;
}


# ----------------------------------------------------
sub html2js
# ----------------------------------------------------
{
  my $html = shift;
  $html or die "no html here\n";
  my $js = "document.write(''";
  for (split /\n/, $html)
  {
    next unless $_;
    $_ =~ s/\'/\\'/g;
    $js .= "\n + '$_'"
  }
  $js .= ");\n";
  return $js;
}



1;
