
package xCountry;

use DBI;

my $conf = $main::conf;
unless ($conf)
{
  require Conf;
  $conf = new Conf;
  $conf->read('/opt/x-rates/bin/x-rates.v2.conf') || die "$@\n";;
}
$main::conf = $conf;


my $cache = {};
sub load
{
  my $dbh;
  $dbh = DBI->connect(
                      "DBI:mysql:$conf->{sql_database}:$conf->{sql_server}",
                      "$conf->{sql_user}",
                      "$conf->{sql_password}",
                      {
                       PrintError => 1,
                       RaiseError => 1
                      }
                     );
  die unless $dbh;

  my $q = 'SELECT * from country_info';

  my $sth = $dbh->prepare('SELECT * from country_info');
  unless ($sth && $sth->execute)
  {
    $@ = "SQL statement error: $dbh->errstr";
    return undef;
  }

  while (my $ref = $sth->fetchrow_hashref)
  {
    $cache->{$ref->{iso4217}} = $ref;
  }

  $sth->finish;
  $dbh->disconnect;

  return bless $cache;
}


# heavily depricated, this only works for one country
sub new
{
  my ($self, $in) = @_;
  die unless $conf;

  # connect to SQL server
  my $dbh;
  $dbh = DBI->connect(
                      "DBI:mysql:$conf->{sql_database}:$conf->{sql_server}",
                      "$conf->{sql_user}",
                      "$conf->{sql_password}",
                      {
                       PrintError => 1,
                       RaiseError => 1
                      }
                     );
  die unless $dbh;

  my $q = 'SELECT * from country_info WHERE ';

  if (length($in) == 2) {
    $q .= "iso3166 = '$in'";
  }
  elsif (length($in) == 3) {
    $q .= "iso4217 = '$in'";
  } else {
    $q .= "country like '\%$in'";
  }

  my $sth = $dbh->prepare($q);
  unless ($sth && $sth->execute)
  {
    $@ = "SQL statement error: $dbh->errstr";
    return undef;
  }

  $hash_ref = $sth->fetchrow_hashref;

  $sth->finish;
  $dbh->disconnect;

  return $hash_ref;
}

1;
