
package xParser;


use HTML::Template;
use HTML::box;
# use AdBanner;
# use xData; required elsewhere in here

use strict;

my $conf = $main::conf;
unless ($conf)
{
  require Conf;
  $conf = new Conf;
  $conf->read('/opt/x-rates/bin/x-rates.v2.conf') || die;
}

sub new
{
  my ($pckg, $self);
  ($pckg, $conf) = @_;
  return undef unless $conf;

  $self =
  {
    main_template => "$conf->{dir_templates}/$conf->{htdoc_1}",
    header => 'no header given',
    lbar   => '<img src="/img/1x1_clear.gif" width=1 height=1 border=0>',
    banner_code => banner_code()
  };

  return bless $self;
}


sub out
{
  my $s = shift;

  my $t = HTML::Template->new(
			      filename => "$s->{main_template}",
			      die_on_bad_params => 0,
			     );
  $t->param(%$s);
  return $t->output;
}


sub title
{
  my ($s, $i) = @_;
  $s->{title} = $i;
}


sub m_keywords
{
  my ($s, $i) = @_;
  $s->{m_keywords} = qq{<META NAME="keywords" CONTENT="$i">};
}


sub m_description
{
  my ($s, $i) = @_;
  $s->{m_description} = qq{<META NAME="description" CONTENT="$i">};
}


sub shortcut_icon
{
  my ($s, $i) = @_;
  $s->{shortcut_icon} = qq{<LINK REL="SHORTCUT ICON" HREF="$i">};
}


sub no_cache
{
  my ($s, $i) = @_;
  $s->{no_cache} = qq{<META http-equiv="Expires" content="Fri, 30 Oct 1998 14:19:41 GMT"><META http-equiv="Pragma" content="no-cache"><META http-equiv="Cache-Control" content="no-cache">};
}


sub header
{
  my ($s, $i) = @_;
  $s->{header} = $i;
}


sub head_js
{
  my ($s, $i) = @_;
  $s->{head_js} = qq{<script language="JavaScript">
$i
</script>};
}


sub on_load
{
  my ($s, $i) = @_;
  $s->{on_load} = "onLoad=\"$i\"";
}


sub content
{
  my ($s, $i) = @_;
  $s->{content} = $i;
}


sub rbox
{
  my ($s, $n, $content) = @_;
  $content =~ s/^<table/<table width=150/i;
  my $spacer = qq{<img src="/img/1x1_clear.gif" alt="" border=0 width=1 height=15><br>};
  $s->{"rbox$n"} = $content . $spacer;
}


sub lbar
{
  my ($s, $c) = @_;
  $s->{lbar} = $c;
}


sub country_list
{
  my ($s, $i) = @_;

  require xData;

  my %cc = xData::country_list();

  my $links = qq{<font size="-2" face="Verdana">\n};
  for (sort { $cc{$a} cmp $cc{$b} } keys %cc) {
    $links .= qq{. <a href="foobarlink/$_" class="menu">$cc{$_}</a><br>\n};
  }
  $links .= qq{</font>\n};

  # modify links to suit this page
  {
    my ($f, $b) = $i =~ /^(.*)c1c(.*)$/;
    $links =~ s/foobarlink\/(...)/$f$1$b/g;
  }

  my $b = new HTML::box(
			title   => 'Currency',
			footer  => 'bar',
			content => $links,
		       );

  rbox($s, 1, $$b);
}


sub lbar_ads
{
  my $caller = shift;
  $caller =~ s/\///g;
  $caller ||= 'nocaller';

  my $old_burst_bt = qq{
<!-- BEGIN BURST! CODE -->
<iframe SRC="http://www.burstnet.com/cgi-bin/ads/cb8936a.cgi/RETURN-CODE/if/$caller/" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" vspace="0" hspace="0" width="125" height="125">
<A target="_top" HREF="http://www.burstnet.com/ads/cb8936a-map.cgi/nf/$caller">
<IMG SRC="http://www.burstnet.com/cgi-bin/ads/cb8936a.cgi/nf/$caller" border="0" width="125" height="125" alt="Please support our sponsor.">
</A></iframe>
<!-- END BURST! CODE -->
<br><br></center>};

  my $burst_bt = qq{<!-- BEGIN RICH-MEDIA BURST! CODE --> <script language="JavaScript">
<!--
    ShowBurstAd('cb8936a','125','125');
// --></script>
<noscript><a href="http://www.burstnet.com/ads/cb8936a-map.cgi/ns" target="_top">
<img src="http://www.burstnet.com/cgi-bin/ads/cb8936a.cgi/ns" 
width="125" height="125" border="0" alt="Click Here"></a> </noscript>
<!-- END BURST CODE -->
<br><br></center>};

  my $button_ad = q{<iframe src="/phpAdsNew/adframe.php?what=125x125" framespacing="0"
 scrolling="no" marginwidth=0 marginheight=0 frameborder=0 vspace=0 hspace=0 
     width=125 height=125><script language="Javascript" src="/phpAdsNew/adjs.php?what=125x125"></script><noscript><a href="/phpAdsNew/adclick.php"><img src="/phpAdsNew/adview.php?what=125x125"></a></noscript></iframe>};






  my $b = new HTML::box (
			 title  => 'advertising',
			 footer => qq{<center><font face="Verdana" size="-2">
<a href="/faq_ads.html" class="menu">about ads on this site</a></font></center>},
			 width  => 160,
			 content => qq{<center><br>$button_ad},
			);

  return $$b;
}



sub lbar_fxcm
{
  my $caller = shift;
  $caller ||= 'nocaller';
  $caller =~ s/\///g;

  my $fxcm = q{<font size="-1" face="Verdana">
<b>Information</b><br>
. <a href="http://www.fxcmmini.com/analyze-currencies.html">What moves rates?</a><br>
. <a href="http://www.fxcm.com/currency_forecast/eur-usd.html">Currency Forecasts</a><br>
. <a href="http://www.dailyfx.com/tr_charts.html">News & Live Quotes</a><br>
<br>
<b>Currency Trading</b><br>
. <a href="http://www.fxcm.com/fxpowercourse.html">Learn How to Trade</a><br>
. <a href="http://www.fxcm.com/mini-demo-registration.php">Practice Trading</a><br>
. <a href="http://www.fxcmmini.com/">Mini Trading Acct</a><br>
. <a href="http://www.fxcm.com/flashdemo.html">Trading Pre-view</a><br>
<br>
<b>Interests</b><br>
. <a href="/travel-services.html">International Travel</a><br>
. <a href="/business-services.html">International Business</a><br>
. <a href="/investor-services.html">Business Investing</a><br>
<br>
<b>Free Offers</b><br>
. <a href="http://www.fxcm.com/trading-guide-request.html">Trading Guide</a><br>
. <a href="http://www.fxcm.com/mini-demo-registration.php">Virtual Account</a><br>
. <a href="http://www.fxcmmini.com/newsletter.html">Newsletter</a><br>
<br></font>};

  my $b = new HTML::box (
    title  => '<font color="white">FXCM</font>',
    footer => q{bar},
    width  => 160,
    color  => 'black',
    title_color => '#0047BE',
    content => qq{$fxcm},
    );

  return $$b;
}


# . <a href="https://www.foreign-currency.com/cgi-bin/fx/fx.pl?TEMPLATE=x-rates.html&Curr=US+Dollars&Reseller=x-rates" class="aactive">Buy Currency</a><br>

sub main_link_box
{
  my $b = new HTML::box (
			 title  => 'Menu',
			 footer => 'bar',
			 width  => 160,
			 content => qq{<font size="-1" face="Verdana">
. <a href="/calculator.html" class="aactive">Currency Calculator</a><br>
. <a href="/cgicalc.html" class="aactive">Custom Table</a><br>
. <a href="/cgi-bin/hlookup.cgi" class="aactive">Historic Lookup</a><br></font>

},
			);

# . <a href="/flag_list.html" class="aactive">Country Flags</a><br>

# 

  return $$b;
}


sub other_link_box
{
  my $b = new HTML::box (
			 title  => 'More Links',
			 footer => 'bar',
			 width  => 160,
			 content => qq{<font size="-1" face="Verdana">
. <a href="/developers.html" class="aactive">Webmaster Tools</a><br>
. <a href="/faq_euro.html" class="aactive">Euro Information</a><br>
. <a href="/bookmark_me.html" class="aactive">Bookmark help</a><br>
. <a href="/faq.html" class="aactive">Frequent questions</a><br>
. <a href="/feedback.html" class="aactive">Feedback</a><br>
. <a href="/copyright.html" class="aactive">Terms of Service</a><br><br></font>},
			);
  return $$b;
}

sub register_box
{
  my $b = new HTML::box (
			 title  => 'Not what you need ?',
			 footer => 'bar',
			 width  => '',
			 content => qq{<font size="-1" face="Verdana">
 If you need access to remote feeds to your site, historical quotes,
 more powerfull graphing tools, email services or other options that
 are not available here we can make it happen.
<br><br>
 Use our <a href="/feedback.html">feedback form<a/>
 to let us know what you are looking for, some options
 will be made available in our future <i>members</i> section.
</font>}
			);
  return $$b;
}



sub cgicalc_box
{
  my ($ival, $base) = @_;
  require xData;
  $ival ||= 1;
  $base ||= 'USD';

  # currency list for which we have values for last day
  my ($d, $date, $val) = xData::one_day();
  $d->{USD} = 1;

  # build OPTIONS html sorted by currency name.
  my $dropdown = _select_list( keys %$d );

  $dropdown =~ s/"$base">/"$base" selected>/i;

  my $b = new HTML::box (
			 title  => 'Convert',
			 footer => '<center>into all other currencies</center>',
			 width => '350',
			 content =>
qq{<form action="$conf->{domain}/cgi-bin/cgicalc.cgi" method="GET">
<input type="text" size=10 name="value" value="$ival">
<select name="base" size=1>
$dropdown
</select>
<input TYPE="Submit" VALUE="go"><br>
</form>}
			);
  return $$b;
}



sub calculator_box
{
  my ($ival, $base, $target, @in) = @_;
  my %in = @in unless (@in % 2);

  require xData;
  $ival ||= 1;
  $base ||= 'USD';

  # currency list for which we have values for last day
  my ($d, $date, $val) = xData::one_day();
  $d->{USD} = 1;

  # build OPTIONS html sorted by currency name.
  my $dropdown = _select_list( keys %$d );
  my $tdropdown = $dropdown;

  $dropdown  =~ s/"$base">/"$base" selected>/i;
  $tdropdown =~ s/"$target">/"$target" SELECTED>/i;

  my $action = $in{action};
  $action ||= "$conf->{domain}/cgi-bin/calculator.cgi";

  my $b = new HTML::box (
                         title  => '&nbsp;',
			 title_align => 'center',
                         footer => '&nbsp;',
                         width => '350',
                         content =>
			 qq{<center><br>
<form action="$action" method="GET">
<font face="Verdana" size="2">
Amount&nbsp;<input type="text" size=8 name="value" value="$ival">
&nbsp;
From&nbsp;<select name="base" size=1>
$dropdown
</select><br><br>

To&nbsp;&nbsp;
<select name="target" size=1>
$tdropdown
</select>
&nbsp;&nbsp;
<input TYPE="Submit" VALUE="Convert"></font></form>}
			 );
  return $$b;
}



sub table_box
{

  my $dropdown = _select_list();

  my $b = new HTML::box (
			 title  => 'Table',
			 footer => 'bar',
			 close_form => 1,
			 content => qq{
<FORM ACTION="/cgi-bin/show" METHOD="GET">
<input type="hidden" name="action" value="table">
<input type="hidden" name="ccode" value="USD">
<SELECT NAME="ccode2">
$dropdown
    </SELECT>&nbsp;&nbsp;<input type="Submit" value="GO">}
			);
  return $$b;
}


sub graph_box
{

  my $dropdown = _select_list();
  my $b = new HTML::box (
			 title  => 'Graph',
			 footer => 'bar',
			 close_form => 1,
			 content => qq{
<font FACE="Verdana, Arial" SIZE="-1" COLOR=black>
<FORM ACTION="/cgi-bin/show" METHOD="GET">
<input type="hidden" name="action" value="graph">
<SELECT NAME="ccode">
$dropdown
</SELECT><br>
<SELECT name="ccode2">
$dropdown
</select>&nbsp;&nbsp;<input type="Submit" value="GO"><br>
<input TYPE="Radio" NAME="gtype" VALUE="120" CHECKED>120 days<br>
<input TYPE="Radio" NAME="gtype" VALUE="2003">2003 monthly average</font>}
			 );
  return $$b;
}


sub show_box
{

  my $dropdown = _select_list();

  my $b = new HTML::box (
			 title  => 'Exchange Rates',
			 footer => 'bar',
			 content => qq{
<FORM ACTION="/cgi-bin/show" METHOD="GET">
<input type="hidden" name="ccode" value='USD'>
<font FACE="Verdana, Arial" SIZE="-2" COLOR=black>
TABLE<input TYPE="Radio" NAME="action" VALUE="table" CHECKED>&nbsp;&nbsp;
GRAPH<input TYPE="Radio" NAME="action" VALUE="graph"><br>
<select name="ccode2">
$dropdown
</select>&nbsp;<input type="Submit" value="GO">
</font>
</FORM>}
			);
  return $$b;
}


sub _select_list
{
  my @countries = @_;

  require xData;
  my %ctry = xData::country_list();
  @countries = keys %ctry unless (scalar @countries);

  my $dropdown;
  for my $c (sort { $ctry{$a} cmp $ctry{$b} }  @countries)
  {
    $dropdown .= qq{<option VALUE="$c">$ctry{$c}\n};
#    my $t = $ctry{$c};
#    `echo "$t = $c" >> /tmp/lala`
#    `rm -f /tmp/lala`;
  }

  return $dropdown;
  
}


sub banner_code
{
  my $page  = shift;

  my $burst = qq{
<!-- BEGIN RICH-MEDIA BURST! CODE --> 
<script language="JavaScript"> 
<!-- /*  1997-2001 BURST! Media, LLC. All Rights Reserved.*/ 
var TheAdcode = 'ad8936a'; 
var bN = navigator.appName; 
var bV = parseInt(navigator.appVersion); 
var base='http://www.burstnet.com/'; 
var Tv=''; 
var agt=navigator.userAgent.toLowerCase(); 
if (bV>=4) 
  {ts=window.location.pathname+window.location.search; 
   i=0; Tv=0; while (i< ts.length) 
      { Tv=Tv+ts.charCodeAt(i); i=i+1; } Tv="/"+Tv;} 
  else   {Tv=escape(window.location.pathname); 
   if( Tv.charAt(0)!='/' ) Tv="/"+Tv; 
          else if (Tv.charAt(1)=="/")
Tv=""; 
  if( Tv.charAt(Tv.length-1) == "/") 
    Tv = Tv + "_";} 
if (bN=='Netscape'){ 
     if ((bV>=4)&&(agt.indexOf("mac")==-1))
{  document.write('<s'+'cript src="'+ 
      base+'cgi-bin/ads/'+TheAdcode+'.cgi/RETURN-CODE/JS' 
      +Tv+'">'); 
     document.write('</'+'script>');    
} 
     else if (bV>=3) {document.write('<'+'a href="'+base+'ads/'+ 
        TheAdcode+'-map.cgi'+Tv+'"target=_top>'); 
        document.write('<img src="' + base + 'cgi-bin/ads/' + 
        TheAdcode + '.cgi' + Tv + '" ismap width="468" height="60"' + 
       ' border="0" alt="Click Here"></a>');} 
 } 
if (bN=='Microsoft Internet Explorer') 
 document.write('<ifr'+'ame id="BURST" src="'+base+'cgi-bin/ads/' + 
  TheAdcode + '.cgi' + Tv + '/RETURN-CODE" width="468" height="60"' + 
  'marginwidth="0" marginheight="0" hspace="0" vspace="0" ' + 
  'frameborder="0" scrolling="no"></ifr'+'ame>'); 
// --> 
</script> <noscript><a href="http://www.burstnet.com/ads/ad8936a-map.cgi/ns" target="_top"> 
<img src="http://www.burstnet.com/cgi-bin/ads/ad8936a.cgi/ns" 
width="468" height="60" border="0" alt="Click Here"></a> 
</noscript> 
<!-- END BURST CODE --> 
};

  my $test = '<img src="/img/banners/ani_banner_1.gif" width=468 height=60 border=0>';

  my $flycode =qq{
<!--Begin Engage Ad Copyright 2001  Engage, Inc.
All rights reserved. Patent Pending -->
<script LANGUAGE="JAVASCRIPT">
<!--
    FlycastSite = "ExchangeRates";
FlycastPage = "Exchangeratessite";
FlycastWidth = 468;
FlycastHeight = 60;
FlycastPrintTag = true;
FlycastNewAd = true;
FlycastEnableTargetWindow = false;
FlycastKeyword = "";
FlycastLoaded = false;
FlycastVersion = 3.6;
//-->
</SCRIPT>
<script SRC="http://js-adex3.flycast.com/FlycastUniversal/Version3.6/" LANGUAGE="JAVASCRIPT"></SCRIPT>
<script LANGUAGE="JAVASCRIPT">
<!--
    if (!FlycastLoaded) document.write('<A target="_top" HREF="http://ad-adex3.flycast.com/server/click/ExchangeRates/Exchangeratessite/123"><IMG WIDTH=468 HEIGHT=60 BORDER=0 SRC="http://ad-adex3.flycast.com/server/ad/ExchangeRates/Exchangeratessite/123"></A>');
//-->
</SCRIPT>
<noscript>
<iframe SRC="http://ad-adex3.flycast.com/server/iframe/ExchangeRates/Exchangeratessite/123" scrolling="no" marginwidth=0 marginheight=0 frameborder=0 vspace=0 hspace=0 WIDTH=468 HEIGHT=60>
<a target="_top" HREF="http://ad-adex3.flycast.com/server/click/ExchangeRates/Exchangeratessite/123"><img BORDER=0 WIDTH=468 HEIGHT=60 SRC="http://ad-adex3.flycast.com/server/img/ExchangeRates/Exchangeratessite/123"></a>
</iframe>
</noscript>
<!--End EngageAd Copyright 2001 Engage, Inc. All rights reserved Patent Pending -->
};



  return $flycode;
}




1;
